/*
 * Proyecto: Prueba
 * Fichero: Form1.prg
 * Descripcin:
 * Autor:
 * Fecha: 08/10/2021
 */

#include "Xailer.ch"

CLASS TForm1 FROM TForm

   COMPONENT oArrayBrowse1
   COMPONENT oScreenKeyboard1

   METHOD CreateForm()
   METHOD ArrayBrowse1KeyDown( oSender, nKey, nFlags )
   METHOD ArrayBrowse1ColumnasPostEdit( oSender, Value, lCanceled, nKey )
   METHOD FormInitialize( oSender )
   METHOD ScreenKeyboard1KeyClick( oSender, nKey, @cChar, @nKeyCode )
   METHOD ArrayBrowse1Char( oSender, nKey, nFlags )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

METHOD FormInitialize( oSender ) CLASS TForm1
   Local aDatos := {}, nConta := 1

   For nConta := 1 To 50
      AAdd( aDatos, {StrZero(nConta,6,0),0,0,""} )
   Next

   ::oArrayBrowse1:aArrayData := aDatos
   ::oArrayBrowse1:SetFocus()
   ::oArrayBrowse1:SelectCol(2)

RETURN Nil

//------------------------------------------------------------------------------

METHOD ArrayBrowse1KeyDown( oSender, nKey, nFlags ) CLASS TForm1
   Local oCol := oSender:SelectedCol(), nRegistro := 0
   Local cKey := ""

   If nKey == VK_RETURN
      nRegistro := oSender:KeyNo()
      oSender:GoDown() //Baja en una unidad la actual fila del browse
      If oSender:KeyNo() == nRegistro  // Si no me puedo mover de registro es que estoy al final
         PostMessage(oSender:Handle, WM_KEYDOWN, VK_INSERT,VK_CONTROL)
      EndIf
   ElseIf nKey == VK_F2
      If !oSender:lEditMode
         oCol:Edit()  // No mando ningun parametro
      EndIf
   //ElseIf nKey <> VK_ESCAPE
   //   If !Empty( cKey := VKeyToASCII( nKey, nFlags ) ) .AND. !oSender:lEditMode
   //      oCol:Edit( Asc(cKey) )
   //      RETURN 0
   //   EndIf
   EndIf

RETURN Nil

//------------------------------------------------------------------------------

METHOD ArrayBrowse1Char( oSender, nKey, nFlags ) CLASS TForm1
   Local xReturn := 0, nRegistro := 0
   Local oCol := oSender:SelectedCol()

   If nKey <> VK_RETURN
      If !oSender:lEditMode
         oCol:Edit(nKey)
      Else
         xReturn := Nil
      EndIf
   EndIf

RETURN xReturn

//------------------------------------------------------------------------------

METHOD ArrayBrowse1ColumnasPostEdit( oSender, Value, lCanceled, nKey ) CLASS TForm1
   Local nColIndex := oSender:nIndex

   If  lCanceled .OR. nKey == 0
      lCanceled := .T.
      RETURN Nil
   EndIf

   oSender:oParent:SetValue(nColIndex,Value)

   PostMessage(oSender:oParent:Handle, WM_KEYDOWN, VK_RETURN)

RETURN Nil

//------------------------------------------------------------------------------

METHOD ScreenKeyboard1KeyClick( oSender, nKey, cChar, nKeyCode ) CLASS TForm1
   //AltD()
RETURN Nil

//------------------------------------------------------------------------------
